library generate_argument;

import "package:stream_binder/stream_binder.dart";

String serverside_header = """
import "arguments.dart";
import "dart:convert";
import "dart:async";
""";

String clientside_header = """
import "arguments.dart";
import "dart:convert";
import "dart:async";
""";

void main() {

  var empty = new GeneratedType("Empty", {});

  var type_a = new GeneratedType("TypeA", {
    "int_param": int_type,
    "string_param": string_type,
    "datetime_param": datetime_type,
    "bool_param": bool_type
  });

  var type_a_list = new ListType(type_a);

  var type_b = new GeneratedType("TypeB", {
    "type_a": type_a,
    "type_a_list": type_a_list
  });

  var genelate_converter_types = [int_type, string_type, bool_type, datetime_type, int_list_type, string_list_type, bool_list_type, datetime_list_type, empty, type_a, type_a_list, type_b];

  generate("tmp/arguments.dart", [empty, type_a, type_b], genelate_converter_types, new EndPoint("tmp/serverside.dart", serverside_header, [], []), new EndPoint("tmp/clientside.dart", clientside_header, [], []));


}
