part of stream_binder;

class _SenderStatements {
  List<Execute> executes;
  List<ExecuteResult> execute_results;
  _SenderStatements(this.executes, this.execute_results);

  String toString() {
    var sb = new StringBuffer();
    for (int x = 0; x < executes.length; x++) {
      var execute = executes[x];
      var method_name = execute.method_name;
      var request_type_name = execute.request_type.type_name;
      var encoder_name = execute.request_type.encoder_name;
      printExecute(sb, method_name, x, request_type_name, encoder_name);
    }
    
    for(int x = 0 ; x < execute_results.length ; x ++){
      var execute_result = execute_results[x];
      var method_name = execute_result.method_name;
      var response_type_name = execute_result.response_type.type_name;
      var response_decoder_name = execute_result.response_type.decoder_name;
      var request_type_name = execute_result.request_type.type_name;
      var request_encoder_name = execute_result.request_type.encoder_name;
      printExecuteResult(
          sb,
          method_name,
          x + executes.length,
          response_type_name,
          response_decoder_name,
          request_type_name,
          request_encoder_name);
    }
    return sb.toString();
    
  }

  void printExecute(StringBuffer sb, String method_name, int x, String request_type_name, String encoder_name) {
    sb
        ..writeln("  void $method_name($request_type_name data){")
        ..writeln("    _send($x,$encoder_name(data));")
        ..writeln("  }");

  }

  void printExecuteResult(StringBuffer sb,
                          String method_name,
                          int x , 
                          String response_type_name,
                          String response_decoder_name, 
                          String request_type_name,
                          String request_encoder_name) {
    sb
        ..writeln("  Future<$response_type_name> $method_name($request_type_name data){")
        ..writeln("    var request_id = _send( $x , $request_encoder_name(data));")
        ..writeln("    return _await(request_id).then((response){")
        ..writeln("      return new Future.value($response_decoder_name(response));")
        ..writeln("    });")
        ..writeln("  }")
        ;
  }
}