library stream_binder;

import "dart:io";

part "types.dart";
part "type_converter_generators.dart";
part "send_method_generators.dart";
part "switch_case_generators.dart";
part "abstract_listeners_generators.dart";
part "stream_binder_generator.dart";

class Execute {

  final String method_name;
  final JsonType request_type;

  Execute(this.method_name, this.request_type);
}

class ExecuteResult {
  final String method_name;
  final JsonType request_type, response_type;
  ExecuteResult(this.method_name, this.request_type, this.response_type) {

  }
}

class EndPoint {

  final String filename;
  final String header;

  final List<Execute> executes;
  final List<ExecuteResult> execute_result;

  EndPoint(this.filename, this.header, this.executes, this.execute_result);
}

void generate(String argument_filename, List<GeneratedType> genelate_types,List<JsonType> create_converter_types, EndPoint server, EndPoint client) {
  var arguments_file_writer = new File(argument_filename).openWrite();
  for (var type in genelate_types) {
    var type_code = _generateType(type);
    arguments_file_writer.writeln(type_code);
  }
  arguments_file_writer.close();

  var sb = new StringBuffer();
  for (var type in create_converter_types) {
    sb
        ..writeln(type.encoder)
        ..writeln(type.decoder);
  }
  var converters = sb.toString();
  
  var server_file = new File(server.filename).openWrite()
      ..writeln(server.header)
      ..writeln(new _StreamBinderGenerator(server, client).toString())
      ..writeln(new _ListenerGenerator(client).toString())
      ..writeln(converters)
      ..close();
  
  var client_file = new File(client.filename).openWrite()
      ..writeln(client.header)
      ..writeln(new _StreamBinderGenerator(client,server).toString())
      ..writeln(new _ListenerGenerator(server).toString())
      ..writeln(converters)
      ..close();
      

}
