part of stream_binder;

class _StreamBinderGenerator {
  _SwitchCaseStatementGenerator switch_case_statement;
  _SenderStatements sender_statements;
  _StreamBinderGenerator(EndPoint sendside_endpoint, EndPoint listenside_endpoint){
    switch_case_statement = new _SwitchCaseStatementGenerator(listenside_endpoint.executes, listenside_endpoint.execute_result);
    sender_statements = new _SenderStatements(sendside_endpoint.executes, sendside_endpoint.execute_result);
  }

  String _template() {
    return """
class StreamBinder {
  int _request_id = 0;
  Listeners _listeners;
  Map<int, Completer> _completers = {};
  StreamController _sc = new StreamController();
  Stream<String>get stream => _sc.stream;
  StreamBinder(this._listeners);
$sender_statements
  int _send(int method_id, data) {
    var i = _request_id++;
    _sc.add(JSON.encode([true, i, method_id, data]));
    return i;
  }

  Future _await(int request_id) {
    var completer = new Completer();
    _completers[request_id] = completer;
    return completer.future;
  }

  void _sendResponse(int request_id, body) {
    _sc.add(JSON.encode([false, request_id, body]));
  }
  
  //いずれはStreamConsumerとして実装したいが責任がよくわからない。
  void addStream(Stream stream){
    stream.listen((json){
      List data = JSON.decode(json);
      bool is_request = data[0];
      int request_id = data[1];

      if (is_request) {
        int method_id = data[2];
        var body = data[3];
        switch (method_id) {
$switch_case_statement
        }
      }else{
        var body = data[2];
        _completers[request_id].complete(body);
      }
    });
  }

}
""";
  }

  String toString() {
    return _template();
  }
}