part of stream_binder;

class _SwitchCaseStatementGenerator {
  List<Execute> executes;
  List<ExecuteResult> execute_results;

  _SwitchCaseStatementGenerator(this.executes, this.execute_results);

  String toString() {
    var sb = new StringBuffer();

    var space = "          ";

    for (int x = 0; x < executes.length; x++) {
      var execute = executes[x];
      var method_name = execute.method_name;
      var decoder_name = execute.request_type.decoder_name;
      sb
          ..writeln(space + "case $x:")
          ..writeln(space + "  _listeners.${method_name}Then($decoder_name(body));")
          ..writeln(space + "  break;");

    }

    for (int x = 0; x < execute_results.length; x++) {
      var execute_result = execute_results[x];
      var case_id = x + executes.length;
      var method_name = execute_result.method_name;
      var decoder_name = execute_result.request_type.decoder_name;
      var encoder_name = execute_result.response_type.encoder_name;

      sb
          ..writeln(space + "case $case_id :")
          ..writeln(space + "  _listeners.${method_name}Then($decoder_name(body)).then((response){")
          ..writeln(space + "    _sendResponse($case_id,$encoder_name(response));")
          ..writeln(space + "  });")
          ..writeln(space + "break;");


    }

    return sb.toString();

  }

}
