part of stream_binder;

class _GeneratedTypeDecoderCreator {
  GeneratedType generated_type;
  _GeneratedTypeDecoderCreator(this.generated_type);

  String get decoder_name => generated_type.decoder_name;
  String get type_name => generated_type.type_name;
  Map<String, JsonType> get params => generated_type.params;

  String get decoder {
    var sb = new StringBuffer();
    writeFirstLine(sb);
    writeGetInstanceLine(sb);
    int x = 0;
    params.forEach((name, type) => writeSetParamValue(sb, x++, name, type));
    writeLastLine(sb);
    return sb.toString();
  }

  void writeFirstLine(StringBuffer sb) {
    sb.writeln("$type_name $decoder_name(List data){");
  }

  void writeGetInstanceLine(StringBuffer sb) {
    sb.writeln("  var instance = new $type_name();");
  }

  void writeSetParamValue(StringBuffer sb, int x, String param_name, JsonType param_type) {
    var param_decoder_name = param_type.decoder_name;
    sb.writeln("  instance.$param_name = $param_decoder_name(data[$x]);");
  }

  void writeLastLine(StringBuffer sb) {
    sb.writeln("  return instance;");
    sb.writeln("}");
  }
}

class _GeneratedTypeEncoderCreator {
  GeneratedType generated_type;
  _GeneratedTypeEncoderCreator(this.generated_type);

  String get encoder_name => generated_type.encoder_name;
  String get type_name => generated_type.type_name;
  Map<String, JsonType> get params => generated_type.params;

  String get encoder {
    var sb = new StringBuffer();
    writeFirstLine(sb);
    params.forEach((name, type) => writeGetParamValue(sb, name, type));
    writeLastLine(sb);
    return sb.toString();
  }

  void writeFirstLine(StringBuffer sb) {
    sb.writeln("List $encoder_name($type_name data){");
    sb.writeln("  List list = [];");
  }

  void writeGetParamValue(StringBuffer sb, String param_name, JsonType param_type) {
    var sub_type_encoder_name = param_type.encoder_name;
    sb.writeln("  list.add($sub_type_encoder_name(data.$param_name));");
  }

  void writeLastLine(StringBuffer sb) {
    sb.writeln("  return list;");
    sb.writeln("}");

  }

}

String _generateType(GeneratedType type) {
  var type_name = type.type_name;
  var variable_declarations = _getVariableDeclarations(type.params);
  return 
      "class $type_name {\n"
      "$variable_declarations"
      "}";
}

String _getVariableDeclarations(Map<String, JsonType> type_map) {
  var sb = new StringBuffer();
  type_map.forEach((var_name, type) => _writeVariableDeclaration(sb, type.type_name, var_name));
  return sb.toString();
}

void _writeVariableDeclaration(StringBuffer sb, String type_name, String var_name) {
  sb.writeln("  $type_name $var_name;");
}