library serverside;
import "arguments.dart";
import "dart:convert";
import "dart:async";

class StreamBinder {
  int _request_id = 0;
  Listeners _listeners;
  Map<int, Completer> _completers = {};
  StreamController _sc = new StreamController();
  Stream<String>get stream => _sc.stream;
  StreamBinder(this._listeners);

  int _send(int method_id, data) {
    var i = _request_id++;
    _sc.add(JSON.encode([true, i, method_id, data]));
    return i;
  }

  Future _await(int request_id) {
    var completer = new Completer();
    _completers[request_id] = completer;
    return completer.future;
  }

  void _sendResponse(int request_id, body) {
    _sc.add(JSON.encode([false, request_id, body]));
  }
  
  //いずれはStreamConsumerとして実装したいが責任がよくわからない。
  void addStream(Stream stream){
    stream.listen((json){
      List data = JSON.decode(json);
      bool is_request = data[0];
      int request_id = data[1];

      if (is_request) {
        int method_id = data[2];
        var body = data[3];
        switch (method_id) {
          case 0:
            _listeners.sendDateTimeThen(_DateTimeDecoder(body));
            break;

        }
      }else{
        var body = data[2];
        _completers[request_id].complete(body);
      }
    });
  }

}

abstract class Listeners{
  void sendDateTimeThen(DateTime data);
}

int _DateTimeEncoder(DateTime data) => data.millisecondsSinceEpoch;
DateTime _DateTimeDecoder(int data) => new DateTime.fromMillisecondsSinceEpoch(data);

