import "tmp/server.dart" as server;
import "tmp/client.dart" as client;
import "tmp/arguments.dart";
import "package:unittest/unittest.dart";

void main() {
  var ssb = new server.StreamBinder(new SL());
  var csb = new client.StreamBinder(new CL());

  ssb.addStream(csb.stream);
  csb.addStream(ssb.stream);

  var type_a1 = new TypeA()
      ..num1 = 0
      ..num2 = 1;
  var type_a2 = new TypeA()
      ..num1 = 2
      ..num2 = 3;
  var type_a3 = new TypeA()
      ..num1 = 4
      ..num2 = 5;
  var type_b = new TypeB()
      ..type_a = type_a1
      ..type_a_list = [type_a2, type_a3];

  test("TypeBを転送するTest",(){
    csb.sendB(type_b);
    
  });


}


class SL implements server.Listeners {
  void sendBThen(TypeB data) {
    assert(data.type_a.num1 == 0);
    assert(data.type_a.num2 == 1);
    assert(data.type_a_list[0].num1 == 2);
    assert(data.type_a_list[0].num2 == 3);
    assert(data.type_a_list[1].num1 == 4);
    assert(data.type_a_list[1].num2 == 5);
    
    
  }
}

class CL implements client.Listeners {

}
