library clientside;
import "arguments.dart";
import "dart:convert";
import "dart:async";

class StreamBinder {
  int _request_id = 0;
  Listeners _listeners;
  Map<int, Completer> _completers = {};
  StreamController _sc = new StreamController();
  Stream<String>get stream => _sc.stream;
  StreamBinder(this._listeners);
  void sendB(TypeB data){
    _send(0,_TypeBEncoder(data));
  }

  int _send(int method_id, data) {
    var i = _request_id++;
    _sc.add(JSON.encode([true, i, method_id, data]));
    return i;
  }

  Future _await(int request_id) {
    var completer = new Completer();
    _completers[request_id] = completer;
    return completer.future;
  }

  void _sendResponse(int request_id, body) {
    _sc.add(JSON.encode([false, request_id, body]));
  }
  
  //いずれはStreamConsumerとして実装したいが責任がよくわからない。
  void addStream(Stream stream){
    stream.listen((json){
      List data = JSON.decode(json);
      bool is_request = data[0];
      int request_id = data[1];

      if (is_request) {
        int method_id = data[2];
        var body = data[3];
        switch (method_id) {

        }
      }else{
        var body = data[2];
        _completers[request_id].complete(body);
      }
    });
  }

}

abstract class Listeners{
}

List _TypeAEncoder(TypeA data){
  List list = [];
  list.add(_IntEncoder(data.num1));
  list.add(_IntEncoder(data.num2));
  return list;
}

TypeA _TypeADecoder(List data){
  var instance = new TypeA();
  instance.num1 = _IntDecoder(data[0]);
  instance.num2 = _IntDecoder(data[1]);
  return instance;
}

List _TypeAListTypeEncoder(List data) => new List.generate(data.length, (i) => _TypeAEncoder(data[i]));
List<TypeA> _TypeAListTypeDecoder(List data) => new List.generate(data.length,(i) => _TypeADecoder(data[i]));
List _TypeBEncoder(TypeB data){
  List list = [];
  list.add(_TypeAEncoder(data.type_a));
  list.add(_TypeAListTypeEncoder(data.type_a_list));
  return list;
}

TypeB _TypeBDecoder(List data){
  var instance = new TypeB();
  instance.type_a = _TypeADecoder(data[0]);
  instance.type_a_list = _TypeAListTypeDecoder(data[1]);
  return instance;
}

int _IntEncoder(int data)=> data;
int _IntDecoder(int data)=> data;

