library clientside;
import "arguments.dart";
import "dart:convert";
import "dart:async";

class StreamBinder {
  int _request_id = 0;
  Listeners _listeners;
  Map<int, Completer> _completers = {};
  StreamController _sc = new StreamController();
  Stream<String>get stream => _sc.stream;
  StreamBinder(this._listeners);
  Future<TypeB> cul(TypeA data){
    var request_id = _send( 0 , _TypeAEncoder(data));
    return _await(request_id).then((response){
      return new Future.value(_TypeBDecoder(response));
    });
  }

  int _send(int method_id, data) {
    var i = _request_id++;
    _sc.add(JSON.encode([true, i, method_id, data]));
    return i;
  }

  Future _await(int request_id) {
    var completer = new Completer();
    _completers[request_id] = completer;
    return completer.future;
  }

  void _sendResponse(int request_id, body) {
    _sc.add(JSON.encode([false, request_id, body]));
  }
  
  //いずれはStreamConsumerとして実装したいが責任がよくわからない。
  void addStream(Stream stream){
    stream.listen((json){
      List data = JSON.decode(json);
      bool is_request = data[0];
      int request_id = data[1];

      if (is_request) {
        int method_id = data[2];
        var body = data[3];
        switch (method_id) {

        }
      }else{
        var body = data[2];
        _completers[request_id].complete(body);
      }
    });
  }

}

abstract class Listeners{
}

List _TypeAEncoder(TypeA data){
  List list = [];
  list.add(_IntEncoder(data.num_1));
  list.add(_IntEncoder(data.num_2));
  return list;
}

TypeA _TypeADecoder(List data){
  var instance = new TypeA();
  instance.num_1 = _IntDecoder(data[0]);
  instance.num_2 = _IntDecoder(data[1]);
  return instance;
}

List _TypeBEncoder(TypeB data){
  List list = [];
  list.add(_IntEncoder(data.add));
  list.add(_IntEncoder(data.sub));
  list.add(_IntEncoder(data.mul));
  list.add(_IntEncoder(data.div));
  return list;
}

TypeB _TypeBDecoder(List data){
  var instance = new TypeB();
  instance.add = _IntDecoder(data[0]);
  instance.sub = _IntDecoder(data[1]);
  instance.mul = _IntDecoder(data[2]);
  instance.div = _IntDecoder(data[3]);
  return instance;
}

int _IntEncoder(int data)=> data;
int _IntDecoder(int data)=> data;

